#include <bits/stdc++.h>
#define ednl "\n"
using namespace std;

int sum[1000001],br[1000001],rod[1000001];

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n,ans=0,p,m,now=0;
    cin>>n;

    for(int i=1;i<=n;i++){
        cin>>p>>m;
        if(m>0){
            br[i]=br[p]+1;
            now=sum[p]+m;
            sum[i]=now;
            ans+=now;
            rod[i]=p;
        }else{
            now=sum[rod[p]];
            sum[i]=now;
            ans+=now;
            rod[i]=rod[rod[p]];
        }
    }

    cout<<ans<<endl;
    return 0;
}

